"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("@feathersjs/transport-commons");
const base_1 = require("@feathersjs/transport-commons/lib/channels/channel/base");
const channels_utils_1 = require("./channels.utils");
const getModelName_1 = __importDefault(require("../utils/getModelName"));
const filterChannels_1 = __importDefault(require("./filterChannels"));
exports.default = (app, data, context, _options) => {
    const { channels } = app;
    // skip if there are no channels
    if (!(channels === null || channels === void 0 ? void 0 : channels.length)) {
        return undefined;
    }
    const options = (0, channels_utils_1.makeOptions)(app, _options);
    const { channelOnError, activated } = options;
    const modelName = (0, getModelName_1.default)(options.modelName, context);
    if (!activated || !modelName) {
        return (!channelOnError) ? new base_1.Channel() : app.channel(channelOnError);
    }
    return (0, filterChannels_1.default)(app, data, context, app.channel(channels), options);
};
